import pulumi
import pulumi_aws
from pulumi_aws import organizations

from cloudlib.utils.names import IdentifierV2


def get_organization_unit(config):
    organization_provider = pulumi_aws.provider.Provider(
        resource_name=IdentifierV2("provider_organization").snake,
        assume_role=pulumi_aws.provider.ProviderAssumeRoleArgs(
            external_id="078020966649",
            role_arn="arn:aws:iam::078020966649:role/OrganizationInfoRole",
        ),
    )

    return organizations.get_organizational_unit_descendant_accounts(
        parent_id=config.get("organization-unit"),
        opts=pulumi.InvokeOptions(provider=organization_provider),
    )
