import pulumi
from pulumi_aws import secretsmanager as sm

from cloudlib.utils.names import IdentifierV2


class ServiceSecretsFactory:
    def __init__(self, service):
        self.service = service
        self.secrets = {}

    def include(self, name, value):
        self.secrets[name] = value

    def create(self):
        secret = sm.Secret(resource_name=IdentifierV2("secret_" + self.service).snake, name=f"/services/{self.service}")
        sm.SecretVersion(
            resource_name=IdentifierV2("secret_" + self.service + "_version").snake,
            secret_id=secret.id,
            secret_string=pulumi.Output.json_dumps(self.secrets),
        )

        return secret
