from pulumi_aws import ssm

from cloudlib.utils.names import Identifier, IdentifierV2
from cloudlib.aws.ssm import parameter as parameter_v2


def parameter(name, value, type="String", idf=None, id_suffix="", **kwargs):
    names = [name] if not isinstance(name, list) else name
    results = []
    for name in names:
        results.append(
            ssm.Parameter(
                resource_name=Identifier(idf or name).add(id_suffix), name=name, value=value, type=type, **kwargs
            )
        )

    if len(results) == 1:
        return results[0]
    else:
        return results


def get_parameter(name, **kwargs):
    kwargs.setdefault("with_decryption", True)
    return ssm.get_parameter(name, **kwargs)
