from collections import namedtuple


class NetworkInfo:
    def __init__(
        self,
        attachment_id,
        attachment_route_table_id,
        workload_route_table_id,
        zone_id,
        vpc_id,
        dns_rules,
        subnets_private,
        endpoint_zones=None,
        vpc=None,
    ):
        self.attachment_id = attachment_id
        self.attachment_route_table_id = attachment_route_table_id
        self.workload_route_table_id = workload_route_table_id
        self.zone_id = zone_id
        self.vpc_id = vpc_id
        self.dns_rules = dns_rules
        self.subnets_private = subnets_private
        self.endpoint_zones = endpoint_zones
        self.vpc = vpc


TransitGateway = namedtuple("TransitGateway", ["id", "identifier"])


class ShareInfo(dict):
    def __init__(self, stack, *args, **kwargs):
        super(ShareInfo, self).__init__(*args, **kwargs)
        self.__dict__ = self
        self.stack = stack

    def get_output(self, name):
        return self.stack.get_output(name)

    def get(self, prefix):
        return {k: v for k, v in self.items() if str(k).startswith(prefix)}
